#include <stdlib.h>
#include <stdio.h>
#include "libcompte.h"

/* affiche le solde d'un compte */
void do_lire_solde(int fd) {
  int cpt;
  int solde;

  printf("Quel compte ?\n");
  scanf("%d", &cpt);
  int ret = lire_solde(fd, cpt, &solde);
  if(ret < 0 ) {
    printf("Erreur lors de la lecture du compte %d\n", cpt);
    return;
  }
  printf("solde du compte %d: %d\n", cpt, solde);
}


/* transfere de l'argent d'un compte a un autre */
void do_transfert(int fd) {
  int cpt_src;
  int cpt_dest;
  int montant;
  printf("Quel compte débitter ?\n");
  scanf("%d", &cpt_src);
  printf("Quel compte créditter ?\n");
  scanf("%d", &cpt_dest);
  printf("Montant du transfert ?\n");
  scanf("%d", &montant);
  transfert(fd, cpt_src, cpt_dest, montant);
}

/* affiche le solde de tous les comptes */
void do_solde_tous_comptes(int fd) {
  for(int i = 0; i<nb_compte(fd); i++) {
    int solde;
    int ret = lire_solde(fd, i, &solde);
    if(ret < 0) {
      printf("Erreur lors de la lecture du compte %d\n",i);
      return;
    }
    printf("Compte %d : %d\n", i, solde);
  }
}

/* affiche la balance */
void do_balance(int fd) {
  int b = balance(fd);
  printf("Balance: %d\n", b);
}

/* cree un nouveau compte */
void do_nouveau_compte(int fd) {
  int montant;
  printf("Montant initial ?\n");
  scanf("%d", &montant);
  creer_compte(fd, montant);
}

int main(int argc, char**argv) {
  int choix;
  char* compte_name = "compte.dat";
  int fd = compte_init(compte_name);
  if(fd < 0){
    perror("cannot open file\n");
    exit(EXIT_FAILURE);
  }

  do {
    printf("----------------------------\n");
    printf("0 - Quitter\n");
    printf("1 - Lire le solde d'un compte\n");
    printf("2 - Afficher le solde de tous les comptes\n");
    printf("3 - Transfert d'un compte à l'autre\n");
    printf("4 - Calculer la balance\n");
    printf("5 - Nouveau compte\n");
    printf("----------------------------\n");
    scanf("%d", &choix);
    switch(choix) {
    case 1:
      do_lire_solde(fd);
      break;
    case 2:
      do_solde_tous_comptes(fd);
      break;
    case 3:
      do_transfert(fd);
      break;
    case 4:
      do_balance(fd);
      break;
    case 5:
      do_nouveau_compte(fd);
      break;
    case 0:
      printf("Au revoir\n");
      break;
    default:
      printf("Choix invalide\n");
      break;
    }
  } while(choix != 0);

  compte_finalize(fd);
  return EXIT_SUCCESS;
}
