#include <stdio.h>
#include <stdlib.h>
#include "libcompte.h"

static int ecrire_solde(int fd, int cpt_id, int new_solde);

/* Ouvre un fichier compte et retourne le fd a passer aux autres fonctions */
int compte_init(const char* filename) {

  /* A COMPLETER */

  return -1;
}

/* Ferme un fichier compte */
void compte_finalize(int fd) {

  /* A COMPLETER */

}

/* Cree un nouveau compte */
void creer_compte(int fd, int montant) {
  int cpt_id = nb_compte(fd);
  int ret = ecrire_solde(fd, cpt_id, montant);
  if(ret < 0) {
    printf("Erreur lors de la création du compte %d\n", cpt_id);
    return;
  }
}

/* Ecrit le solde d'un compte
 * retourne -1 en cas d'erreur ou 0 sinon
 */
static int ecrire_solde(int fd, int cpt_id, int new_solde) {

  /* A COMPLETER */

  return -1;
}

/* Lit le solde d'un compte.
 * retourne -1 en cas d'erreur ou 0 sinon
 */
int lire_solde(int fd, int cpt_id, int*solde) {

  /* A COMPLETER */

  return -1;
}

/* Retourne le nombre de comptes stockés dans le fichier
 */
int nb_compte(int fd) {

  /* A COMPLETER */

  return -1;
}


/* Transfere montant euros du compte cpt_src au compte cpt_dest
 */
void transfert(int fd, int cpt_src, int cpt_dest, int montant) {
  /* transfere entre deux comptes */
  int solde_src, solde_dest;
  int ret = lire_solde(fd, cpt_src, &solde_src);
  if(ret < 0) {
    printf("Erreur lors de la lecture du solde %d\n", cpt_src);
    return;
  }
  ret = lire_solde(fd, cpt_dest, &solde_dest);
  if(ret < 0) {
    printf("Erreur lors de la lecture du solde %d\n", cpt_dest);
    return;
  }
  solde_src -= montant;
  solde_dest += montant;
  ret = ecrire_solde(fd, cpt_src, solde_src);
  if(ret < 0) {
    printf("Erreur lors de l'ecriture du solde %d\n", cpt_src);
    return;
  }

  ret = ecrire_solde(fd, cpt_dest, solde_dest);
  if(ret < 0) {
    printf("Erreur lors de l'ecriture du solde %d\n", cpt_dest);
    return;
  }
}

/* Calcule la somme de tous les comptes
 */
int balance(int fd) {
  int somme = 0;
  int ncpt = nb_compte(fd);
  for(int i=0; i<ncpt; i++) {
    int solde;
    lire_solde(fd, i, &solde);
    somme += solde;
  }

  return somme;
}
