#ifndef LIBCOMPTE_H
#define LIBCOMPTE_H
#include <unistd.h> // Q1.1 : le code compile, mais il y a des warning, corrigez les
#include <fcntl.h>
#include <errno.h>


/* Ouvre un fichier compte et retourne le fd a passer aux autres fonctions */
int compte_init(const char* filename);

/* Ferme un fichier compte */
void compte_finalize(int fd);

/* Cree un nouveau compte */
void creer_compte(int fd, int montant);

/* Lit le solde d'un compte.
 * retourne -1 en cas d'erreur ou 0 sinon
 */
int lire_solde(int fd, int cpt_id, int*solde);

/* Retourne le nombre de comptes stockés dans le fichier
 */
int nb_compte(int fd);

/* Transfere montant euros du compte cpt_src au compte cpt_dest
 */
void transfert(int fd, int cpt_src, int cpt_dest, int montant);

/* Calcule la somme de tous les comptes
 */
int balance(int fd);

#endif	/* LIBCOMPTE_H */
